Unit TypeText;

Interface

Uses
  Crt,
  Dos{,
  Graph};

{Function GetText(X1,Y1,X2,Y2: Integer; InitString: String; Fore,Back: Byte; MaxLen,WindowLen: Integer): String;}
Function _BufLen(WX,WY: Integer; InitString: String; Fore,Back: Byte; MaxLen,WindowLen: Integer): String;

Implementation

Uses ProtMenu;
(*
Function GetText(X1,Y1,X2,Y2: Integer; InitString: String; Fore,Back: Byte; MaxLen,WindowLen: Integer): String;
{ ---------------------------------------------------------------------- }
{ Allows the user to type in a text string in BGI graphics mode          }
{    X1 ................. Upper left X coord of text input box           }
{    Y1 ................. Upper left Y coord of text input box           }
{    X2 ................. Lower right X coord of text input box          }
{    Y2 ................. Lower right Y coord of text input box          }
{    InitString ......... Initial text string                            }
{    Fore ............... Text foreground color                          }
{    Back ............... Text background color                          }
{    MaxLen ............. Maximum string length                          }
{    WindowLen .......... Displayed string length, for scrollable window }
{ ---------------------------------------------------------------------- }
Var
  Work : String;
  Ch   : Char;
  Ch1  : Char;
  Top  : Integer;
  X    : Integer;
  Ins  : Boolean;
  TPtr : Pointer;
  On   : Boolean;

  Function Max(A,B: Integer): Integer;
  { --------------------------------- }
  { Returns the higher of two numbers }
  { --------------------------------- }
  InLine(
    $5A/        { POP   AX    }
    $58/        { POP   DX    }
    $39/$D0/    { CMP   AX,DX }
    $7F/$02/    { JG    @L1   }
    $89/$D0);   { MOV   AX,DX }
                { @L1:        }
  { Max }

  Function Min(A,B: Integer): Integer;
  { -------------------------------- }
  { Returns the lower of two numbers }
  { -------------------------------- }
  InLine(
    $5A/        { POP   AX    }
    $58/        { POP   DX    }
    $39/$D0/    { CMP   AX,DX }
    $7C/$02/    { JL    @L1   }
    $89/$D0);   { MOV   AX,DX }
                { @L1:        }
  { Min }


  Procedure _Bar(X1,Y1,X2,Y2: Integer);
  { -------------------------------------------------------------------- }
  { Draws a filled box, allows reverse-video by using BGI Line procedure }
  { -------------------------------------------------------------------- }
  Var I: Integer;
  Begin
    For I := Min(Y1,Y2) To Max(Y1,Y2) Do Line(X1,I,X2,I);
  End; { _Bar }


  Procedure Cursor;
  { --------------------------------- }
  { Toggle to display/hide the cursor }
  { --------------------------------- }
  Begin
    If On Then
    Begin
      SetColor(Back);
      SetFillStyle(SolidFill,Back);
    End
    Else
    Begin

    End;
    If Ins
     Then _Bar(X1 + (X - Top)     * TextWidth('M') + 1,Y1 + 1,
               X1 + (X - Top + 1) * TextWidth('M'),Y1 + TextHeight('Mg'))
     Else Line(X1 + (X - Top)     * TextWidth('M') + 1,Y1 + TextHeight('Mg'),
               X1 + (X - Top + 1) * TextWidth('M'),Y1 + TextHeight('Mg'));
    SetColor(Fore);
    SetWriteMode(CopyPut);
    SetFillStyle(SolidFill,Fore);
    On := Not On;
  End; { Cursor }


  Procedure ScrollLeft;
  { --------------------------- }
  { Scroll the text window left }
  { --------------------------- }
  Begin
    Inc(Top);
    GetMem(TPtr,ImageSize(X1 + TextWidth('M') + 1,Y1,X2,Y2));
    GetImage(X1 + TextWidth('M') + 1,Y1,X2,Y2,TPtr^);
    SetColor(Back);
    SetFillStyle(SolidFill,Back);
    SetWriteMode(CopyPut);
    Bar(X1 + (WindowLen - 1) * TextWidth('M') + 1,Y1,X2,Y2);
    SetColor(Fore);
    PutImage(X1,Y1,TPtr^,CopyPut);
    OutTextXY(X1 + (WindowLen - 1) * TextWidth('M') + 1,Y1 + 1,Copy(Work,Top + WindowLen,1));
    FreeMem(TPtr,ImageSize(X1 + TextWidth('M') + 1,Y1,X2,Y2));
  End; { ScrollLeft }


  Procedure ScrollRight;
  { ---------------------------- }
  { Scroll the text window right }
  { ---------------------------- }
  Begin
    Dec(Top);
    GetMem(TPtr,ImageSize(X1 + TextWidth('M') + 1,Y1,X2 + (WindowLen - 1) * TextWidth('M'),Y2));
    GetImage(X1 + TextWidth('M') + 1,Y1,X2 + (WindowLen - 1) * TextWidth('M'),Y2,TPtr^);
    SetColor(Back);
    SetFillStyle(SolidFill,Back);
    SetWriteMode(CopyPut);
    Bar(X1,Y1,X1 + TextWidth('M'),Y2);
    SetColor(Fore);
    PutImage(X1 + TextWidth('M') + 1,Y1,TPtr^,CopyPut);
    OutTextXY(X1 + 1,Y1 + 1,Copy(Work,Top,1));
    FreeMem(TPtr,ImageSize(X1 + TextWidth('M') + 1,Y1,X2,Y2));
  End; { ScrollRight }

Begin
  Work := InitString;{'';}
  Top  := 1;
  X    := 1;
  Ins  := False;
  On   := False;

  { Blank the window }

  SetColor(Back);
  SetFillStyle(SolidFill,Back);
  SetWriteMode(CopyPut);
  SetLineStyle(SolidLn,0,NormWidth);
  Bar(X1,Y1,X2,Y2);
  SetColor(Fore);
  OutTextXY(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen));

  Cursor;
  Ch := ' ';
  While Not (Ch In [#13,#27]) Do
  Begin
    If KeyPressed Then
    Begin
      Ch := ReadKey;
      Case Ch Of
   #13,#27: Begin
            End;
        #8: Begin                                   { Backspace }
              If X > 1 Then
              Begin
                Cursor;
                Delete(Work,X - 1,1);
                If X > Top Then
                Begin
                  SetColor(Back);
                  SetWriteMode(CopyPut);
                  SetFillStyle(SolidFill,Back);
                  Bar(X1 + (X - Top - 1) * TextWidth('M') + 1,Y1 + 1,X2 - 1,Y2 - 1);
                  SetColor(Fore);
                  OutTextXY(X1 + (X - Top - 1) * TextWidth('M') + 1,Y1 + 1,Copy(Work,X - 1,WindowLen - (X - Top) + 1));
                End;
                Dec(X);
                If X < Top Then ScrollRight;
                Cursor;
              End;
            End;
        #0: Begin
              While Not KeyPressed Do Begin End;
              Ch1 := ReadKey;
              Case Ch1 Of
                #71: If X > 1 Then                  { Home }
                     Begin
                       Cursor;
                       If Top <> 1 Then
                       Begin
                         SetColor(Back);
                         SetFillStyle(SolidFill,Back);
                         SetWriteMode(CopyPut);
                         Bar(X1,Y1,X2,Y2);
                         SetColor(Fore);
                         Top := 1;
                         OutTextXY(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen));
                       End;
                       X := 1;
                       Cursor;
                     End;
                #75: If X > 1 Then                  { Cursor Left }
                     Begin
                       Cursor;
                       Dec(X);
                       If X < Top Then ScrollRight;
                       Cursor;
                     End;
                #77: If X <= Length(Work) Then      { Cursor Right }
                     Begin
                       Cursor;
                       Inc(X);
                       If X - Top = WindowLen Then ScrollLeft;
                       Cursor;
                     End;
                #79: If X <= Length(Work) Then      { End }
                     Begin
                       Cursor;
                       If Top < Length(Work) - WindowLen + 2 Then
                       Begin
                         SetColor(Back);
                         SetFillStyle(SolidFill,Back);
                         SetWriteMode(CopyPut);
                         Bar(X1,Y1,X2,Y2);
                         SetColor(Fore);
                         Top := Length(Work) - WindowLen + 2;
                         OutTextXY(X1 + 1,Y1 + 1,Copy(Work,Top,WindowLen));
                       End;
                       X := Length(Work) + 1;
                       Cursor;
                     End;
                #82: Begin                          { Insert }
                       Cursor;
                       Ins := Not Ins;
                       Cursor;
                     End;
                #83: Begin                          { Delete }
                       If ((Work <> '') And (X <= Length(Work))) Then
                       Begin
                         Cursor;
                         Delete(Work,X,1);
                         SetColor(Back);
                         SetWriteMode(CopyPut);
                         SetFillStyle(SolidFill,Back);
                         Bar(X1 + (X - Top) * TextWidth('M') + 1,Y1 + 1,X2 - 1,Y2 - 1);
                         SetColor(Fore);
                         OutTextXY(X1 + (X - Top) * TextWidth('M') + 1,Y1 + 1,Copy(Work,X,WindowLen - (X - Top)));
                         Cursor;
                       End;
                     End;
              End; { Case }
            End;
      Else
        Cursor;
        If (X > Length(Work)) Or Ins Then
        Begin
          If (Length(Work) < MaxLen) Then
          Begin
            Insert(Ch,Work,X);
            SetColor(Back);
            SetWriteMode(CopyPut);
            SetFillStyle(SolidFill,Back);
            Bar(X1 + (X - Top) * TextWidth('M') + 1,Y1 + 1,X2 - 1,Y2 - 1);
            SetColor(Fore);
            OutTextXY(X1 + (X - Top) * TextWidth('M') + 1,Y1 + 1,Copy(Work,X,WindowLen - (X - Top)));
          End;
        End
        Else
        Begin
          Work[X] := Ch;
          SetColor(Back);
          SetWriteMode(CopyPut);
          SetFillStyle(SolidFill,Back);
          Bar(X1 + (X - Top)     * TextWidth('M') + 1,Y1 + 1,
              X1 + (X - Top + 1) * TextWidth('M')    ,Y2 - 1);
          SetColor(Fore);
          OutTextXY(X1 + (X - Top) * TextWidth('M') + 1,Y1 + 1,Copy(Work,X,1));
        End;
        If Not ((X > Length(Work)) And (Length(Work) = MaxLen)) Then
        Begin
          Inc(X);
           { Check to see if I must scroll the text left }
           If X - Top = WindowLen Then ScrollLeft;
        End;
        Cursor;
      End; { Case }
    End;
  End; { While }
  If Ch = #27 Then Work := InitString;
  SetColor(Back);
  SetFillStyle(SolidFill,Back);
  SetWriteMode(CopyPut);
  Bar(X1,Y1,X2,Y2);
  SetColor(Fore);
  OutTextXY(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen));
  GetText := Work;
End; { GetText }
*)

Function _BufLen(WX,WY: Integer; InitString: String; Fore,Back: Byte; MaxLen,WindowLen: Integer): String;
{ ---------------------------------------------------------------------- }
{ Allows the user to type in a text string                               }
{    X .................. X coord of text input box                      }
{    Y .................. Y coord of text input box                      }
{    InitString ......... Initial text string                            }
{    Fore ............... Text foreground color                          }
{    Back ............... Text background color                          }
{    MaxLen ............. Maximum string length                          }
{    WindowLen .......... Displayed string length, for scrollable window }
{ ---------------------------------------------------------------------- }
Var
  Work : String;
  Ch   : Char;
  Ch1  : Char;
  Top  : Integer;
  X    : Integer;
  Ins  : Boolean;
  TPtr : Pointer;
  On   : Boolean;
  Key  : Boolean;

  Procedure Cursor;
  { --------------------------------- }
  { Toggle to display/hide the cursor }
  { --------------------------------- }
  Var Regs: Registers;
  Begin
    On := Not On;
    If On Then
    Begin
      If Ins Then Screen.SetCursor(6,7) Else Screen.SetCursor(0,7);
    End;
    Screen.ShowCursor(On);
(*
      If Ins Then
      Begin
        Regs.AH := 1;
        Regs.AL := Mem[Seg0040:$49];
        Regs.CX := $0607;
        Intr($10,Regs);
      End
      Else
      Begin
        Regs.AH := 1;
        Regs.AL := Mem[Seg0040:$49];
        Regs.CX := $0007;
        Intr($10,Regs);
      End;
    End
    Else
    Begin
      Regs.AH := 1;
      Regs.AL := Mem[Seg0040:$49];
      Regs.CX := $2607;
      Intr($10,Regs);
    End;
*)
    Screen.GotoXY(WX + X - Top,WY);
  End; { Cursor }


  Procedure WriteStr;
  Var
    St : String;
    I  : Integer;

  Begin
    St := Copy(Work,Top,WindowLen);
    I  := Length(St);
    While Length(St) < WindowLen Do St := St + ' ';
    Screen.GotoXY(WX,WY);
    Screen.Write(St);
    Screen.GotoXY(WX + X - Top,WY);
  End; { WriteStr }


  Procedure ScrollLeft;
  { --------------------------- }
  { Scroll the text window left }
  { --------------------------- }
  Begin
    Inc(Top);
    WriteStr;
  End; { ScrollLeft }


  Procedure ScrollRight;
  { ---------------------------- }
  { Scroll the text window right }
  { ---------------------------- }
  Begin
    Dec(Top);
    WriteStr;
  End; { ScrollRight }

Begin

  { Blank the window }

  Screen.TextColor(Fore);
  Screen.TextBackground(Back);
  Work := InitString;{'';}
  While Length(Work) < WindowLen Do Work := Work + ' ';
  Screen.GotoXY(WX,WY);
  Screen.Write(Work);
  Screen.GotoXY(WX,WY);

  Work := InitString;{'';}
  Top  := 1;
  X    := 1;
  Ins  := True;
  On   := False;
  Key  := False;

  Cursor;
  Ch := ' ';
  While Not (Ch In [#13,#27]) Do
  Begin
    If KeyPressed Then
    Begin
      Ch := ReadKey;
      Case Ch Of
   #13,#27: Begin
            End;
        #8: Begin                                   { Backspace }
              If X > 1 Then
              Begin
                Cursor;
                Delete(Work,X - 1,1);
                If X > Top Then WriteStr;
                Dec(X);
                If X < Top Then ScrollRight;
                Cursor;
              End;
            End;
        #0: Begin
              While Not KeyPressed Do Begin End;
              Ch1 := ReadKey;
              Case Ch1 Of
                #71: If X > 1 Then                  { Home }
                     Begin
                       Cursor;
                       If Top <> 1 Then
                       Begin
                         Top := 1;
                         WriteStr;
                       End;
                       X := 1;
                       Cursor;
                     End;
                #75: If X > 1 Then                  { Cursor Left }
                     Begin
                       Cursor;
                       Dec(X);
                       If X < Top Then ScrollRight;
                       Cursor;
                     End;
                #77: If X <= Length(Work) Then      { Cursor Right }
                     Begin
                       Cursor;
                       Inc(X);
                       If X - Top = WindowLen Then ScrollLeft;
                       Cursor;
                     End;
                #79: If X <= Length(Work) Then      { End }
                     Begin
                       Cursor;
                       If Top < Length(Work) - WindowLen + 2 Then
                       Begin
                         Top := Length(Work) - WindowLen + 2;
                         WriteStr;
                       End;
                       X := Length(Work) + 1;
                       Cursor;
                     End;
                #82: Begin                          { Insert }
                       Cursor;
                       Ins := Not Ins;
                       Cursor;
                     End;
                #83: Begin                          { Delete }
                       If ((Work <> '') And (X <= Length(Work))) Then
                       Begin
                         Cursor;
                         Delete(Work,X,1);
                         WriteStr;
                         Cursor;
                       End;
                     End;
              End; { Case }
            End;
      Else
        Cursor;
        If Not Key Then
        Begin
          Work := Ch;    { If the user just started typing, replace the }
          WriteStr;      { string outright                              }
          Key := True;
        End
        Else
        Begin
          If (X > Length(Work)) Or Ins Then
          Begin
            If (Length(Work) < MaxLen) Then
            Begin
              Insert(Ch,Work,X);
              WriteStr;
            End;
          End
          Else
          Begin
            Work[X] := Ch;
            WriteStr;
          End;
        End;
        If Not ((X > Length(Work)) And (Length(Work) = MaxLen)) Then
        Begin
          Inc(X);
          { Check to see if I must scroll the text left }
          If X - Top = WindowLen Then ScrollLeft;
        End;
        Cursor;
      End; { Case }
    End;
  End; { While }
  If Ch = #27 Then Work := InitString;
  Screen.GotoXY(WX,WY);
  WriteStr;
  _BufLen := Work;
End; { _BufLen }

End.

// ----------------------------------------------------------------------
// PCAE - PC Atari Emulator - Atari 2600 Emulator for MS-DOS
// Copyright (C) 2000 John Dullea
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// ----------------------------------------------------------------------

